<?php

	require("../_init.php");
	require("../_connect.php");
	require("../_funcdb.php");
	require("../_funcstd.php");

	$bukadb = DBSelect( DATABASE_NAME );

	if ($bukadb) {
		die( "Database: " . DATABASE_NAME . " already exist !" );
	}

	$perintahdb = "CREATE DATABASE IF NOT EXISTS " . DATABASE_NAME . " DEFAULT CHARACTER SET utf8 DEFAULT COLLATE utf8_general_ci";

	if ( @DBQuery( $perintahdb ) === false ) {
		die( "Error creating database: " . DATABASE_NAME . CRLF . "(" . DBError() . ")" );
	}

	$bukadb = DBSelect( DATABASE_NAME );

	if (!$bukadb) {
		die( "Error opening database: " . DATABASE_NAME . CRLF . "(" . DBError() . ")" );
	}

	$struct = array();

	require("dbcabang.php");
	require("dbluntip.php");
	require("dbpelang.php");
	require("dbmutasi.php");
	require("dbuser.php");
	require("dbkontro.php");

	foreach ( $struct as $table => $cols ) {

		if ( !IsTableExists( $table ) ) {

			$createtable = 'CREATE TABLE ' . $table . ' (';

			foreach ( $cols as $field => $detail ) {

				if ( $field == 'Key' ) {

					foreach ( $detail as $key => $keyvalue ) {
						$createtable = $createtable . 'KEY ' . $key . ' (' . $keyvalue . '),';
					}

				} elseif ( $field == 'UniqueKey' ) {

					foreach ( $detail as $unique => $uniquekeyvalue ) {
						if ( !array_key_exists('PrimaryKey',$cols) OR strpos( $cols['PrimaryKey'], $uniquekeyvalue ) === FALSE ) {
							$createtable = $createtable . 'UNIQUE INDEX ' . $unique . ' (' . $uniquekeyvalue . ' ASC),';
						}
					}

				} elseif ( $field == 'CreateIfNotExist' ) {
					// do nothing ...
				} else {

					if ( $field == 'PrimaryKey' ) {
						$createtable = $createtable . 'PRIMARY KEY (' . $detail . '),';
					} else {
						$createtable = $createtable . $field . ' ' . $detail . ',';
					}

				}

			}

			if ( substr( $createtable, strlen($createtable) - 1, 1 ) == ',' ) {
				$createtable = substr( $createtable, 0, strlen($createtable) - 1 );
			}

			$createtable = $createtable . ') ENGINE=InnoDB DEFAULT CHARSET=utf8';

			if ( @DBQuery( $createtable ) === false ) {
				die( "Error creating table $table" . CRLF . DBError() . CRLF . $createtable );
			}

		}

	}

	$perintahdb = "INSERT INTO tblcontrol (DBVersion,StartData,Validasi) VALUES (" . DATABASE_VERSION . ",'" . date('Ymd') . "','" . $_POST['validasi'] . "')";

	@DBQuery( $perintahdb );

	$perintahdb = "INSERT INTO tbluser (User,Password,Level,InputBy,InputDateTime) VALUES ('Admin','123',1,-1,'" . date("Y-m-d H:i:s") . "')";

	@DBQuery( $perintahdb );

	$perintahdb = "INSERT INTO tblcabang (KodeCabang,NamaCabang,Input_Oleh,Input_DateTime) VALUES (1,'Pusat',-1,'" . date("Y-m-d H:i:s") . "')";

	@DBQuery( $perintahdb );

	die( "Ok:1" );


	function IsTableExists( $table ) { 

		$sqlquery = @DBQuery("SHOW TABLES");

		while ( list($temp) = @DBFetchArray($sqlquery) ) {

			if ( $temp == $table OR $temp == strtolower($table) ) {
				return TRUE;
			}

		}

		return FALSE;
	}
?>